> ## Documentation Index
> Fetch the complete documentation index at: https://auth0.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Create an Identity Provider

> Create a new enterprise Identity Provider utilizing the specified configuration settings and details for this Auth0 Organization.



## OpenAPI

````yaml docs/oas/myorganization/myorganization-api-oas.json POST /identity-providers
openapi: 3.1.0
info:
  title: My Organization API
  description: My Organization API
  termsOfService: https://auth0.com/web-terms/
  version: 1.0.0
  license:
    name: UNLICENSED
    url: https://auth0.com
servers:
  - url: https://{tenantDomain}/my-org/v1
    variables:
      tenantDomain:
        default: '{TENANT}.auth0.com'
        description: Auth0 Tenant Domain
  - url: https://{tenantDomain}/my-org
    variables:
      tenantDomain:
        default: '{TENANT}.auth0.com'
        description: Auth0 Tenant Domain
security: []
tags:
  - name: config
    description: Configuration
    x-displayName: Configuration
  - name: orgManagement
    description: Manage your organization.
    x-displayName: Organization Management
  - name: orgDetails
    description: Manage details related to your organization.
    x-displayName: Organization Details Management
  - name: idpManagement
    description: Manage Identity Providers for your Organization.
    x-displayName: Identity Provider Management
  - name: userStoresManagement
    description: Manage User Stores for your Organization.
    x-displayName: User Stores Management
  - name: orgDomainManagement
    description: Manage domains related to your organization
    x-displayName: Domain Management
  - name: orgMemberManagement
    description: Manage members related to your organization
    x-displayName: Member Management
  - name: clientGrantManagement
    description: Manage client grants for your organization
    x-displayName: Client Grant Management
  - name: clientManagement
    description: Manage API clients for your organization
    x-displayName: Client Management
  - name: roles
    description: Manage roles for your organization
    x-displayName: Roles
  - name: orgGroupManagement
    description: Manage connection groups for your organization
    x-displayName: Group Management
paths:
  /identity-providers:
    post:
      tags:
        - idpManagement
      summary: Create an Identity Provider
      description: >-
        Create a new enterprise Identity Provider utilizing the specified
        configuration settings and details for this Auth0 Organization.
      operationId: CreateOrganizationIdentityProvider
      parameters: []
      requestBody:
        $ref: '#/components/requestBodies/CreateIdentityProviderRequest'
      responses:
        '201':
          $ref: '#/components/responses/CreateIdentityProviderResponse'
        '400':
          $ref: '#/components/responses/ClientErrorBadRequestResponse'
        '401':
          $ref: '#/components/responses/ClientErrorUnauthorizedResponse'
        '403':
          $ref: '#/components/responses/ClientErrorInsufficientScopeResponse'
        '404':
          $ref: '#/components/responses/ClientErrorNotFoundOrganizationResponse'
        '409':
          $ref: '#/components/responses/ClientErrorIdpCreateConflictResponse'
        '429':
          $ref: '#/components/responses/ClientErrorTooManyRequestsResponse'
      security:
        - OAuth2ClientCredentials:
            - create:my_org:identity_providers
        - OAuth2AuthCode:
            - create:my_org:identity_providers
      x-codeSamples:
        - lang: typescript
          label: Create an Identity Provider
          source: |
            import { MyOrganizationClient } from "@auth0/myorganization-js";

            async function main() {
                const client = new MyOrganizationClient({
                    domain: "{YOUR_DOMAIN}",
                    token: "<token>",
                });
                await client.organization.identityProviders.create({
                    strategy: "oidc",
                    options: {
                        type: "front_channel",
                        client_id: "a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d",
                        client_secret: "KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp",
                        discovery_url: "https://{yourDomain}/.well-known/openid-configuration",
                    },
                    name: "oidcIdp",
                    domains: [
                        "mydomain.com",
                    ],
                    display_name: "OIDC IdP",
                    show_as_button: true,
                    assign_membership_on_login: false,
                    is_enabled: true,
                });
            }
            main();
        - lang: javascript
          label: Create an Identity Provider
          source: |
            import { MyOrganizationClient } from "@auth0/myorganization-js";

            async function main() {
                const client = new MyOrganizationClient({
                    domain: "{YOUR_DOMAIN}",
                    token: "<token>",
                });
                await client.organization.identityProviders.create({
                    strategy: "oidc",
                    options: {
                        type: "front_channel",
                        client_id: "a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d",
                        client_secret: "KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp",
                        discovery_url: "https://{yourDomain}/.well-known/openid-configuration",
                    },
                    name: "oidcIdp",
                    domains: [
                        "mydomain.com",
                    ],
                    display_name: "OIDC IdP",
                    show_as_button: true,
                    assign_membership_on_login: false,
                    is_enabled: true,
                });
            }
            main();
        - lang: go
          label: Create an Identity Provider
          source: |
            package example

            import (
                context "context"

                myorganization "github.com/auth0/myorganization-go/v2"
                client "github.com/auth0/myorganization-go/v2/client"
                option "github.com/auth0/myorganization-go/v2/option"
            )

            func do() {
                c, err := client.New(
                    "{YOUR_DOMAIN}",
                    option.WithToken(
                        "<token>",
                    ),
                )
                if err != nil {
                    return
                }
                request := &myorganization.IdpKnownRequest{
                    IdpOidcRequest: &myorganization.IdpOidcRequest{
                        Strategy: myorganization.IdpOidcRequestStrategyOidc,
                        Options: &myorganization.IdpOidcOptionsRequest{
                            Type: myorganization.IdpOidcOptionsTypeEnumFrontChannel,
                            ClientID: "a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d",
                            ClientSecret: myorganization.String(
                                "KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp",
                            ),
                            DiscoveryURL: "https://{yourDomain}/.well-known/openid-configuration",
                        },
                        Name: "oidcIdp",
                        Domains: []string{
                            "mydomain.com",
                        },
                        DisplayName: myorganization.String(
                            "OIDC IdP",
                        ),
                        ShowAsButton: myorganization.Bool(
                            true,
                        ),
                        AssignMembershipOnLogin: myorganization.Bool(
                            false,
                        ),
                        IsEnabled: myorganization.Bool(
                            true,
                        ),
                    },
                }
                c.Organization.IdentityProviders.Create(
                    context.TODO(),
                    request,
                )
            }
        - lang: csharp
          label: Create an Identity Provider
          source: |
            using Auth0.MyOrganizationApi;
            using System.Threading.Tasks;
            using System.Collections.Generic;

            public partial class Examples
            {
                public async Task Example() {
                    var client = new MyOrganizationClient(new MyOrganizationClientOptions
                    {
                        Domain = "{YOUR_DOMAIN}",
                        TokenProvider = new DelegateTokenProvider(_ => Task.FromResult("<token>"))
                    });

                    await client.Organization.IdentityProviders.CreateAsync(
                        new IdpOidcRequest {
                            Strategy = IdpOidcRequestStrategy.Oidc,
                            Options = new IdpOidcOptionsRequest {
                                Type = IdpOidcOptionsTypeEnum.FrontChannel,
                                ClientId = "a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d",
                                ClientSecret = "KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp",
                                DiscoveryUrl = "https://{yourDomain}/.well-known/openid-configuration"
                            },
                            Name = "oidcIdp",
                            Domains = new List<string>(){
                                "mydomain.com",
                            }
                            ,
                            DisplayName = "OIDC IdP",
                            ShowAsButton = true,
                            AssignMembershipOnLogin = false,
                            IsEnabled = true
                        }
                    );
                }

            }
        - lang: java
          label: Create an Identity Provider
          source: |-
            package com.example.usage;

            import com.auth0.client.myorganization.auth.MyOrganizationClient;
            import com.auth0.client.myorganization.types.IdpKnownRequest;
            import com.auth0.client.myorganization.types.IdpOidcOptionsRequest;
            import com.auth0.client.myorganization.types.IdpOidcOptionsTypeEnum;
            import com.auth0.client.myorganization.types.IdpOidcRequest;
            import com.auth0.client.myorganization.types.IdpOidcRequestStrategy;
            import java.util.Arrays;
            import java.util.Optional;

            public class Example {
                public static void main(String[] args) {
                    MyOrganizationClient client = MyOrganizationClient
                        .builder()
                        .domain("{YOUR_DOMAIN}")
                        .token("<token>")
                        .build();

                    client.organization().identityProviders().create(
                        IdpKnownRequest.of(
                            IdpOidcRequest
                                .builder()
                                .strategy(IdpOidcRequestStrategy.OIDC)
                                .name("oidcIdp")
                                .options(
                                    Optional.of(
                                        IdpOidcOptionsRequest
                                            .builder()
                                            .type(IdpOidcOptionsTypeEnum.FRONT_CHANNEL)
                                            .clientId("a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d")
                                            .discoveryUrl("https://{yourDomain}/.well-known/openid-configuration")
                                            .clientSecret(Optional.of("KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp"))
                                            .build()
                                    )
                                )
                                .domains(
                                    Optional.of(
                                        Arrays.asList("mydomain.com")
                                    )
                                )
                                .displayName(Optional.of("OIDC IdP"))
                                .showAsButton(Optional.of(true))
                                .assignMembershipOnLogin(Optional.of(false))
                                .isEnabled(Optional.of(true))
                                .build()
                        )
                    );
                }
            }
        - lang: python
          label: Create an Identity Provider
          source: >
            from auth0.myorganization import MyOrganizationClient,
            IdpOidcRequest, IdpOidcOptionsRequest


            client = MyOrganizationClient(
                domain="{YOUR_DOMAIN}",
                token="<token>",
            )


            client.organization.identity_providers.create(
                request=IdpOidcRequest(
                    strategy="oidc",
                    options=IdpOidcOptionsRequest(
                        type="front_channel",
                        client_id="a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d",
                        client_secret="KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp",
                        discovery_url="https://{yourDomain}/.well-known/openid-configuration",
                    ),
                    name="oidcIdp",
                    domains=[
                        "mydomain.com"
                    ],
                    display_name="OIDC IdP",
                    show_as_button=True,
                    assign_membership_on_login=False,
                    is_enabled=True,
                ),
            )
components:
  requestBodies:
    CreateIdentityProviderRequest:
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CreateIdentityProviderRequestContent'
          examples:
            createIdpRequest:
              $ref: '#/components/examples/CreateIdentityProviderRequestExample'
  responses:
    CreateIdentityProviderResponse:
      description: Identity provider successfully created.
      headers:
        X-RateLimit-Limit:
          $ref: '#/components/headers/X-RateLimit-Limit'
        X-RateLimit-Remaining:
          $ref: '#/components/headers/X-RateLimit-Remaining'
        X-RateLimit-Reset:
          $ref: '#/components/headers/X-RateLimit-Reset'
        Retry-After:
          $ref: '#/components/headers/Retry-After'
        X-Auth0-Error-Kind:
          $ref: '#/components/headers/X-Auth0-Error-Kind'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/CreateIdentityProviderResponseContent'
          examples:
            createIdPResponseExample:
              $ref: '#/components/examples/CreateIdentityProviderResponseExample'
    ClientErrorBadRequestResponse:
      description: Invalid request body. The message will vary depending on the cause.
      content:
        application/json:
          schema:
            oneOf:
              - $ref: '#/components/schemas/ErrorResponseContent'
              - $ref: '#/components/schemas/ValidationErrorResponseContent'
          examples:
            errorInvalidJsonExample:
              $ref: '#/components/examples/ErrorBadRequestExample'
            validationErrorExample:
              $ref: '#/components/examples/ErrorValidationExample'
    ClientErrorUnauthorizedResponse:
      description: 'Unauthorized: token missing, invalid or expired.'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseContent'
          examples:
            errorMissingTokenExample:
              $ref: '#/components/examples/ErrorMissingTokenExample'
    ClientErrorInsufficientScopeResponse:
      description: Insufficient scope.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseContent'
          examples:
            errorInsufficientScopeExample:
              $ref: '#/components/examples/ErrorInsufficientScopeExample'
    ClientErrorNotFoundOrganizationResponse:
      description: Organization not found.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseContent'
          examples:
            errorOrgNotFoundExample:
              $ref: '#/components/examples/ErrorOrgNotFoundExample'
    ClientErrorIdpCreateConflictResponse:
      description: >-
        Missing or invalid server configuration (contact tenant admin), or a
        domain is already associated with another identity provider in this
        organization.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseContent'
          examples:
            errorConfigConflictExample:
              $ref: '#/components/examples/ErrorConfigConflictExample'
            errorDomainAssociatedWithOtherIdpExample:
              $ref: '#/components/examples/ErrorDomainAssociatedWithOtherIdpExample'
    ClientErrorTooManyRequestsResponse:
      description: >-
        Too many requests. Check the X-RateLimit-Limit, X-RateLimit-Remaining
        and X-RateLimit-Reset headers.
      headers:
        X-RateLimit-Limit:
          $ref: '#/components/headers/X-RateLimit-Limit'
        X-RateLimit-Remaining:
          $ref: '#/components/headers/X-RateLimit-Remaining'
        X-RateLimit-Reset:
          $ref: '#/components/headers/X-RateLimit-Reset'
        Retry-After:
          $ref: '#/components/headers/Retry-After'
        X-Auth0-Error-Kind:
          $ref: '#/components/headers/X-Auth0-Error-Kind'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponseContent'
          examples:
            errorEndpointRateLimitExample:
              $ref: '#/components/examples/ErrorEndpointRateLimitExample'
  schemas:
    CreateIdentityProviderRequestContent:
      $ref: '#/components/schemas/IdpKnownRequest'
    CreateIdentityProviderResponseContent:
      $ref: '#/components/schemas/IdpKnownResponse'
    ErrorResponseContent:
      type: object
      additionalProperties: false
      required:
        - type
        - status
        - title
        - detail
      properties:
        type:
          type: string
          description: A URI that describes the error.
          format: uri
        status:
          type: integer
          description: The HTTP status code result of the request.
        title:
          type: string
          description: A brief description of the error.
        detail:
          type: string
          description: A detailed description of the error.
    ValidationErrorResponseContent:
      type: object
      additionalProperties: false
      required:
        - type
        - status
        - title
        - validation_errors
      properties:
        type:
          type: string
          description: A URI that describes the error.
          format: uri
        status:
          type: integer
          description: The HTTP status code result of the request.
        title:
          type: string
          description: A brief description of the error.
        validation_errors:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorDetail'
    IdpKnownRequest:
      oneOf:
        - $ref: '#/components/schemas/IdpAdfsRequest'
        - $ref: '#/components/schemas/IdpGoogleAppsRequest'
        - $ref: '#/components/schemas/IdpOidcRequest'
        - $ref: '#/components/schemas/IdpOktaRequest'
        - $ref: '#/components/schemas/IdpPingFederateRequest'
        - $ref: '#/components/schemas/IdpSamlpRequest'
        - $ref: '#/components/schemas/IdpWaadRequest'
    IdpKnownResponse:
      oneOf:
        - $ref: '#/components/schemas/IdpAdfsResponse'
        - $ref: '#/components/schemas/IdpGoogleAppsResponse'
        - $ref: '#/components/schemas/IdpOidcResponse'
        - $ref: '#/components/schemas/IdpOktaResponse'
        - $ref: '#/components/schemas/IdpPingFederateResponse'
        - $ref: '#/components/schemas/IdpSamlpResponse'
        - $ref: '#/components/schemas/IdpWaadResponse'
    ValidationErrorDetail:
      type: object
      additionalProperties: false
      required:
        - detail
      properties:
        detail:
          type: string
          description: A detailed description of the error.
        field:
          type: string
          description: The name of the invalid parameter.
        pointer:
          type: string
          description: >-
            JSON Pointer that points to the exact location of the error in a
            JSON document being validated.
        source:
          type: string
          description: >-
            Specifies the source of the error (e.g., body, query, or header in
            an HTML message).
    IdpAdfsRequest:
      title: IdP ADFS Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: adfs
            options:
              $ref: '#/components/schemas/IdpAdfsOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
            - options
      type: object
      unevaluatedProperties: false
    IdpGoogleAppsRequest:
      title: IdP Google Workforce Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: google-apps
            options:
              $ref: '#/components/schemas/IdpGoogleAppsOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpOidcRequest:
      title: IdP OIDC Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: oidc
            options:
              $ref: '#/components/schemas/IdpOidcOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpOktaRequest:
      title: IdP Okta Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: okta
            options:
              $ref: '#/components/schemas/IdpOktaOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
            - options
      type: object
      unevaluatedProperties: false
    IdpPingFederateRequest:
      title: IdP Ping Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: pingfederate
            options:
              $ref: '#/components/schemas/IdpPingFederateOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
            - options
      type: object
      unevaluatedProperties: false
    IdpSamlpRequest:
      title: IdP SAML Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: samlp
            options:
              $ref: '#/components/schemas/IdpSamlpOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
            - options
      type: object
      unevaluatedProperties: false
    IdpWaadRequest:
      title: IdP Microsoft Azure AD Request
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseRequest'
        - type: object
          properties:
            strategy:
              const: waad
            options:
              $ref: '#/components/schemas/IdpWaadOptionsRequest'
              description: Identity provider specific options.
          required:
            - strategy
            - options
      type: object
      unevaluatedProperties: false
    IdpAdfsResponse:
      title: IdP ADFS Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: adfs
            options:
              $ref: '#/components/schemas/IdpAdfsOptionsResponse'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpGoogleAppsResponse:
      title: IdP Google Workforce Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: google-apps
            options:
              $ref: '#/components/schemas/IdpGoogleAppsOptionsResponse'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpOidcResponse:
      title: IdP OIDC Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: oidc
            options:
              $ref: '#/components/schemas/IdpOidcOptionsResponse'
              description: Identity provider specific options.
            attributes:
              type: array
              items:
                $ref: '#/components/schemas/IdpUserAttributeMapItem'
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpOktaResponse:
      title: IdP Okta Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: okta
            options:
              $ref: '#/components/schemas/IdpOktaOptionsResponse'
              description: Identity provider specific options.
            attributes:
              type: array
              items:
                $ref: '#/components/schemas/IdpUserAttributeMapItem'
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpPingFederateResponse:
      title: IdP Ping Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: pingfederate
            options:
              $ref: '#/components/schemas/IdpPingFederateOptionsResponse'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpSamlpResponse:
      title: IdP SAML Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: samlp
            options:
              $ref: '#/components/schemas/IdpSamlpOptionsResponse'
              description: Identity provider specific options.
            attributes:
              type: array
              items:
                $ref: '#/components/schemas/IdpUserAttributeMapItem'
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpWaadResponse:
      title: IdP Microsoft Azure AD Response
      description: Identity provider specific options.
      allOf:
        - $ref: '#/components/schemas/IdpBaseResponse'
        - type: object
          properties:
            strategy:
              const: waad
            options:
              $ref: '#/components/schemas/IdpWaadOptionsResponse'
              description: Identity provider specific options.
          required:
            - strategy
      type: object
      unevaluatedProperties: false
    IdpBaseRequest:
      allOf:
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/IdpId'
            name:
              type: string
              description: The name of the identity provider
              minLength: 1
              maxLength: 128
            strategy:
              $ref: '#/components/schemas/IdpStrategyEnum'
            domains:
              type: array
              description: List of domains for Home Realm Discovery (HRD)
              items:
                type: string
            display_name:
              type: string
              description: Identity provider name used on the login screen.
              minLength: 1
              maxLength: 128
            show_as_button:
              type: boolean
              description: >-
                Enables showing a button for the connection in the login page
                (new experience only). If false, it will be usable only by Home
                Realm Discovery (HRD).
            assign_membership_on_login:
              type: boolean
              description: >-
                If true, the user will be made a member of the organization upon
                login.
            is_enabled:
              type: boolean
              description: True if the identity provider is enabled for the organization.
            access_level:
              $ref: '#/components/schemas/OrganizationAccessLevelEnum'
              readOnly: true
            use_for_third_party_client_access:
              type: boolean
              description: >-
                True if third-party applications can use it. If false, only
                first-party applications with the connection enabled can use it.
                Defaults to false.
            cross_app_access_resource_app:
              $ref: '#/components/schemas/CrossAppAccessResourceApp'
              description: >-
                Cross-app access resource application configuration. Only
                present when the cross-app access resource application feature
                is enabled for your organization.
              x-release-lifecycle: EA
          required:
            - name
            - strategy
    IdpAdfsOptionsRequest:
      type: object
      oneOf:
        - title: adfs_server
          type: object
          properties:
            adfs_server:
              type: string
              description: >-
                The adfs_server is the public-facing URL that relying parties
                and internal clients use to communicate with an ADFS server for
                authentication and token issuance
          required:
            - adfs_server
          additionalProperties: false
        - title: fedMetadataXml
          type: object
          properties:
            fedMetadataXml:
              type: string
              description: >-
                A Federation Metadata XML file in ADFS is a crucial document
                that serves as a blueprint for establishing trust between an
                ADFS server and other relying parties that want to consume
                identity information from ADFS.
          required:
            - fedMetadataXml
          additionalProperties: false
    IdpGoogleAppsOptionsRequest:
      type: object
      properties:
        domain:
          type: string
          description: Google Workspace domain name for your organization.
        client_id:
          type: string
          description: Unique identifier for your registered Google application.
        client_secret:
          type: string
          description: String used to gain access to your registered Google application
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      required:
        - domain
        - client_id
        - client_secret
      additionalProperties: false
    IdpOidcOptionsRequest:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/IdpOidcOptionsTypeEnum'
        client_id:
          type: string
          description: >-
            The identifier given to you by your provider. Unique identifier for
            your registered application.
        client_secret:
          type: string
          description: >-
            Available if Back Channel is chosen earlier. The secret given to you
            by your provider and each provider manages this step differently.
        discovery_url:
          type: string
          description: >-
            The URL where the OIDC Identity Provider publishes its OpenID
            Provider Configuration Information
      required:
        - discovery_url
        - client_id
        - type
      additionalProperties: false
    IdpOktaOptionsRequest:
      type: object
      properties:
        domain:
          type: string
          description: Okta's domain name for your organization.
        client_id:
          type: string
          description: Unique identifier for your registered Okta application
        client_secret:
          type: string
          description: String used to gain access to your registered Okta application.
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      required:
        - domain
        - client_id
        - client_secret
      additionalProperties: false
    IdpPingFederateOptionsRequest:
      type: object
      properties:
        signatureAlgorithm:
          $ref: '#/components/schemas/IdpSignAlgTypeEnum'
        digestAlgorithm:
          $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
        signSAMLRequest:
          type: boolean
          description: >-
            Indicates whether PingFederate should digitally sign outgoing SAML
            authentication requests to relying parties
        pingFederateBaseUrl:
          type: string
          description: >-
            URL provided by PingFederate which returns information used for
            creating the connection
        signingCert:
          type: string
          description: >-
            PingFederate Server public key (encoded in PEM or CER) you retrieved
            from the IdP
        idpInitiated:
          $ref: '#/components/schemas/IdpOptionsIdpInitiated'
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      required:
        - pingFederateBaseUrl
        - signingCert
        - signatureAlgorithm
        - digestAlgorithm
        - signSAMLRequest
      additionalProperties: false
    IdpSamlpOptionsRequest:
      oneOf:
        - title: automatic
          type: object
          properties:
            metadataUrl:
              type: string
              description: >-
                URL provided by SAML provider which returns information used for
                creating the connection
            signSAMLRequest:
              type: boolean
              description: When enabled, the SAML authentication request will be signed.
            signatureAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgTypeEnum'
            digestAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
            protocolBinding:
              $ref: '#/components/schemas/IdpProtocolBindingTypeEnum'
            bindingMethod:
              type: string
              description: >-
                Defines the specific HTTP binding used for sending SAML
                messages.
            signingCert:
              type: string
              description: >-
                Signing certificate (encoded in PEM or CER) you retrieved from
                the IdP. Optional for this variant: when omitted, the
                certificate is read from the metadata document.
            idpInitiated:
              $ref: '#/components/schemas/IdpOptionsIdpInitiated'
            icon_url:
              type: string
              description: >-
                A URL pointing to an image file that represents your client
                application.
            discovery_url:
              type: string
              description: >-
                OIDC discovery URL of the trusted OIDC provider associated with
                the SAML IdP. Triggers auto-discovery of the OIDC metadata used
                to validate ID-JAGs for cross-app access.
          required:
            - metadataUrl
            - signSAMLRequest
          additionalProperties: false
        - title: manual
          type: object
          properties:
            signInEndpoint:
              type: string
              description: The endpoint URL for the IdP sign-in
            signingCert:
              type: string
              description: >-
                Signing certificate (encoded in PEM or CER) you retrieved from
                the IdP
            signSAMLRequest:
              type: boolean
              description: When enabled, the SAML authentication request will be signed.
            signatureAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgTypeEnum'
            digestAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
            protocolBinding:
              $ref: '#/components/schemas/IdpProtocolBindingTypeEnum'
            bindingMethod:
              type: string
              description: >-
                Defines the specific HTTP binding used for sending SAML
                messages.
            idpInitiated:
              $ref: '#/components/schemas/IdpOptionsIdpInitiated'
            icon_url:
              type: string
              description: >-
                A URL pointing to an image file that represents your client
                application.
            discovery_url:
              type: string
              description: >-
                OIDC discovery URL of the trusted OIDC provider associated with
                the SAML IdP. Triggers auto-discovery of the OIDC metadata used
                to validate ID-JAGs for cross-app access.
          required:
            - signInEndpoint
            - signingCert
            - signSAMLRequest
          additionalProperties: false
    IdpWaadOptionsRequest:
      type: object
      properties:
        tenant_domain:
          type: string
          description: >-
            Your Azure AD domain name. You can find this on your Azure AD
            directory's overview page in the Microsoft Azure portal.
        client_id:
          type: string
          description: Unique identifier for your registered Azure AD application.
        client_secret:
          type: string
          description: String used to gain access to your registered Azure AD application.
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      required:
        - tenant_domain
        - client_id
        - client_secret
      additionalProperties: false
    IdpBaseResponse:
      allOf:
        - type: object
          properties:
            id:
              $ref: '#/components/schemas/IdpId'
            name:
              type:
                - string
                - 'null'
              description: The name of the identity provider
              maxLength: 128
            strategy:
              $ref: '#/components/schemas/IdpStrategyEnum'
            domains:
              type: array
              description: List of domains for Home Realm Discovery (HRD)
              items:
                type: string
            display_name:
              type: string
              description: Identity provider name used on the login screen.
              minLength: 1
              maxLength: 128
            show_as_button:
              type: boolean
              description: >-
                Enables showing a button for the connection in the login page
                (new experience only). If false, it will be usable only by Home
                Realm Discovery (HRD).
            assign_membership_on_login:
              type: boolean
              description: >-
                If true, the user will be made a member of the organization upon
                login.
            is_enabled:
              type: boolean
              description: True if the identity provider is enabled for the organization.
            access_level:
              $ref: '#/components/schemas/OrganizationAccessLevelEnum'
              readOnly: true
            member_access_level:
              $ref: '#/components/schemas/OrganizationMemberAccessLevelEnum'
              description: The Organization Member Access Level for this connection.
              readOnly: true
              x-release-lifecycle: EA
            use_for_third_party_client_access:
              type: boolean
              description: >-
                True if third-party applications can use it. If false, only
                first-party applications with the connection enabled can use it.
                Defaults to false.
            cross_app_access_resource_app:
              $ref: '#/components/schemas/CrossAppAccessResourceApp'
              description: >-
                Cross-app access resource application configuration. Only
                present when the cross-app access resource application feature
                is enabled for your organization.
              x-release-lifecycle: EA
          required:
            - strategy
    IdpAdfsOptionsResponse:
      type: object
      oneOf:
        - title: adfs_server
          type: object
          properties:
            adfs_server:
              type: string
              description: >-
                The adfs_server is the public-facing URL that relying parties
                and internal clients use to communicate with an ADFS server for
                authentication and token issuance
          additionalProperties: false
        - title: fedMetadataXml
          type: object
          properties:
            fedMetadataXml:
              type: string
              description: >-
                A Federation Metadata XML file in ADFS is a crucial document
                that serves as a blueprint for establishing trust between an
                ADFS server and other relying parties that want to consume
                identity information from ADFS.
          additionalProperties: false
    IdpGoogleAppsOptionsResponse:
      type: object
      properties:
        domain:
          type: string
          description: Google Workspace domain name for your organization.
        client_id:
          type: string
          description: Unique identifier for your registered Google application.
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      additionalProperties: false
    IdpOidcOptionsResponse:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/IdpOidcOptionsTypeEnum'
        client_id:
          type: string
          description: >-
            The identifier given to you by your provider. Unique identifier for
            your registered application.
        discovery_url:
          type: string
          description: >-
            The URL where the OIDC Identity Provider publishes its OpenID
            Provider Configuration Information
      additionalProperties: false
    IdpUserAttributeMapItem:
      type: object
      allOf:
        - $ref: '#/components/schemas/BaseUserAttributeMapItem'
        - type: object
          properties:
            sso_field:
              type: array
              items:
                type: string
              description: The name(s) of the sso field.
          required:
            - sso_field
      unevaluatedProperties: false
    IdpOktaOptionsResponse:
      type: object
      properties:
        domain:
          type: string
          description: Okta's domain name for your organization.
        client_id:
          type: string
          description: Unique identifier for your registered Okta application
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      additionalProperties: false
    IdpPingFederateOptionsResponse:
      type: object
      properties:
        signatureAlgorithm:
          $ref: '#/components/schemas/IdpSignAlgTypeEnum'
        digestAlgorithm:
          $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
        signSAMLRequest:
          type: boolean
          description: >-
            Indicates whether PingFederate should digitally sign outgoing SAML
            authentication requests to relying parties
        pingFederateBaseUrl:
          type: string
          description: >-
            URL provided by PingFederate which returns information used for
            creating the connection
        cert:
          type: string
          description: >-
            A value derived from decoding the signingCert. This should not be
            updated directly, instead update the signingCertificate to decode a
            new value for this field
          readOnly: true
        idpInitiated:
          $ref: '#/components/schemas/IdpOptionsIdpInitiated'
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      additionalProperties: false
    IdpSamlpOptionsResponse:
      oneOf:
        - title: automatic
          type: object
          properties:
            metadataUrl:
              type: string
              description: >-
                URL provided by SAML provider which returns information used for
                creating the connection
            signSAMLRequest:
              type: boolean
              description: When enabled, the SAML authentication request will be signed.
            signatureAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgTypeEnum'
            digestAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
            protocolBinding:
              $ref: '#/components/schemas/IdpProtocolBindingTypeEnum'
            bindingMethod:
              type: string
              description: >-
                Defines the specific HTTP binding used for sending SAML
                messages.
            cert:
              type: string
              description: >-
                Signing certificate (encoded in PEM or CER) you retrieved from
                the IdP
            idpInitiated:
              $ref: '#/components/schemas/IdpOptionsIdpInitiated'
            icon_url:
              type: string
              description: >-
                A URL pointing to an image file that represents your client
                application.
            discovery_url:
              type: string
              description: >-
                OIDC discovery URL of the trusted OIDC provider associated with
                the SAML IdP. Triggers auto-discovery of the OIDC metadata used
                to validate ID-JAGs for cross-app access.
          additionalProperties: false
        - title: manual
          type: object
          properties:
            signInEndpoint:
              type: string
              description: The endpoint URL for the IdP sign-in
            cert:
              type: string
              description: >-
                Signing certificate (encoded in PEM or CER) you retrieved from
                the IdP
            signSAMLRequest:
              type: boolean
              description: When enabled, the SAML authentication request will be signed.
            signatureAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgTypeEnum'
            digestAlgorithm:
              $ref: '#/components/schemas/IdpSignAlgDigestTypeEnum'
            protocolBinding:
              $ref: '#/components/schemas/IdpProtocolBindingTypeEnum'
            bindingMethod:
              type: string
              description: >-
                Defines the specific HTTP binding used for sending SAML
                messages.
            idpInitiated:
              $ref: '#/components/schemas/IdpOptionsIdpInitiated'
            icon_url:
              type: string
              description: >-
                A URL pointing to an image file that represents your client
                application.
            discovery_url:
              type: string
              description: >-
                OIDC discovery URL of the trusted OIDC provider associated with
                the SAML IdP. Triggers auto-discovery of the OIDC metadata used
                to validate ID-JAGs for cross-app access.
          additionalProperties: false
    IdpWaadOptionsResponse:
      type: object
      properties:
        tenant_domain:
          type: string
          description: >-
            Your Azure AD domain name. You can find this on your Azure AD
            directory's overview page in the Microsoft Azure portal.
        client_id:
          type: string
          description: Unique identifier for your registered Azure AD application.
        icon_url:
          type: string
          description: >-
            A URL pointing to an image file that represents your client
            application.
      additionalProperties: false
    IdpId:
      type: string
      description: Identity provider identifier.
      readOnly: true
      pattern: ^con_[A-Za-z0-9]{16}$
    IdpStrategyEnum:
      type: string
      description: The type of the identity provider
      enum:
        - adfs
        - google-apps
        - oidc
        - okta
        - pingfederate
        - samlp
        - waad
    OrganizationAccessLevelEnum:
      type: string
      description: The access level allowed for the Organization
      enum:
        - none
        - readonly
        - limited
        - full
    CrossAppAccessResourceApp:
      type: object
      description: Cross-app access resource application configuration.
      properties:
        status:
          $ref: '#/components/schemas/CrossAppAccessResourceAppStatusEnum'
          description: >-
            The status of the cross-app access resource application role. To
            enable the cross-app access resource application role, OIDC issuer
            domain must be a verified domain for the organization.
      required:
        - status
    IdpOidcOptionsTypeEnum:
      type: string
      description: >-
        Select whether authentication exchanges occur via server-to-server
        communication (Back Channel) or through the browser using Implicit Flow
        with Form Post (Front Channel)
      enum:
        - front_channel
        - back_channel
    IdpSignAlgTypeEnum:
      type: string
      description: Select the algorithm used for signing
      enum:
        - rsa-sha256
        - rsa-sha1
    IdpSignAlgDigestTypeEnum:
      type: string
      description: Select the algorithm digest used for signing
      enum:
        - sha256
        - sha1
    IdpOptionsIdpInitiated:
      type: object
      description: >-
        An object containing configuration details for Identity Provider (IdP)
        initiated single sign-on flows
      properties:
        enabled:
          type: boolean
          description: >-
            A flag indicating whether IdP-initiated SSO is enabled for this
            connection
        client_id:
          type: string
          description: >-
            The client ID of your default application for which the
            IdP-initiated flow is being configured
        client_protocol:
          type: string
          description: >-
            This is the protocol used to connect your selected default
            application
        client_authorizequery:
          type: string
          description: >-
            This field represents a template for constructing the authorization
            query string when initiating an IdP-initiated flow to a specific
            client
    IdpProtocolBindingTypeEnum:
      type: string
      description: HTTP binding supported by the IdP.
      enum:
        - urn:oasis:names:tc:SAML:2.0:bindings:HTTP-Redirect
        - urn:oasis:names:tc:SAML:2.0:bindings:HTTP-POST
    OrganizationMemberAccessLevelEnum:
      type: string
      description: >-
        The Organization Member Access Level: what an Organization Administrator
        can do to members authenticated via this connection.
      enum:
        - none
        - readonly
        - limited
        - full
      x-release-lifecycle: EA
    BaseUserAttributeMapItem:
      type: object
      properties:
        user_attribute:
          type: string
          description: The name of the user attribute.
        description:
          type: string
          description: The description of the user attribute.
        label:
          type: string
          description: The label of the user attribute.
        is_required:
          type: boolean
          description: Indicates if the attribute is required.
        is_extra:
          type: boolean
          description: >-
            Indicates whether this attribute is not part of the admin defined
            schema but is provided by the source. The property will be removed
            when a refresh operation is performed.
        is_missing:
          type: boolean
          description: >-
            Indicates whether this attribute is expected but not provided by the
            admin defined schema. The property will be added when a refresh
            operation is performed.
      required:
        - is_required
        - is_extra
        - is_missing
    CrossAppAccessResourceAppStatusEnum:
      type: string
      enum:
        - enabled
        - disabled
      description: The status of the cross-app access resource application.
  examples:
    CreateIdentityProviderRequestExample:
      value:
        name: oidcIdp
        display_name: OIDC IdP
        strategy: oidc
        show_as_button: true
        assign_membership_on_login: false
        domains:
          - mydomain.com
        is_enabled: true
        options:
          type: front_channel
          client_id: a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7d
          client_secret: KzQp2sVxR8nTgMjFhYcEWuLoIbDvUoC6A9B1zX7yWqFjHkGrP5sQdLmNp
          discovery_url: https://{yourDomain}/.well-known/openid-configuration
    CreateIdentityProviderResponseExample:
      value:
        id: con_zW1UHutvkVWSWdCC
        name: oidcIdp
        display_name: OIDC IdP
        strategy: oidc
        show_as_button: true
        assign_membership_on_login: false
        access_level: full
        domains:
          - mydomain.com
        is_enabled: true
        options:
          type: front_channel
          client_id: client_a8f3b2e7-5d1c-4f9a-8b0d-2e1c3a5b6f7did
          discovery_url: https://{yourDomain}/.well-known/openid-configuration
        attributes:
          - sso_field:
              - userName
            user_attribute: preferred_username
            description: Preferred Username
            label: Preferred username
            is_required: true
            is_extra: false
            is_missing: false
          - sso_field:
              - externalId
            user_attribute: external_id
            is_required: true
            is_extra: true
            is_missing: false
    ErrorBadRequestExample:
      value:
        type: https://auth0.com/api-errors#A0E-400-0001
        status: 400
        title: Bad Request
        detail: The request is invalid.
    ErrorValidationExample:
      value:
        type: https://auth0.com/api-errors#A0E-400-0003
        status: 400
        title: Validation Error
        validation_errors:
          - detail: is required
            field: data/property_name
            pointer: /property_name
            source: params
    ErrorMissingTokenExample:
      value:
        type: https://auth0.com/api-errors#A0E-401-0002
        status: 401
        title: Missing Token
        detail: No auth token provided.
    ErrorInsufficientScopeExample:
      value:
        type: https://auth0.com/api-errors#A0E-403-0002
        status: 403
        title: Insufficient Scope
        detail: >-
          The auth token lacks the required scope: Check the API documentation
          for the required scopes for this endpoint.
    ErrorOrgNotFoundExample:
      value:
        type: https://auth0.com/api-errors#A0E-404-0002
        status: 404
        title: Resource Not Found
        detail: The organization does not exist.
    ErrorConfigConflictExample:
      value:
        type: https://auth0.com/api-errors#A0E-409-0001
        status: 409
        title: Configuration issue
        detail: Invalid or missing configuration, please contact tenant admin.
    ErrorDomainAssociatedWithOtherIdpExample:
      value:
        type: https://auth0.com/api-errors#A0E-409-0001
        status: 409
        title: Conflict
        detail: >-
          Domain is already associated with another identity provider in this
          organization. Remove it from that identity provider before associating
          it with this one.
    ErrorEndpointRateLimitExample:
      value:
        type: https://auth0.com/api-errors#A0E-429-0003
        status: 429
        title: Endpoint Rate Limit Exceeded
        detail: The endpoint request limit has been exceeded.
  headers:
    X-RateLimit-Limit:
      description: The number of allowed requests in the current rate limit window.
      schema:
        type: integer
    X-RateLimit-Remaining:
      description: The number of remaining requests in the current rate limit window.
      schema:
        type: integer
    X-RateLimit-Reset:
      description: The Unix timestamp indicating when the current rate limit window resets.
      schema:
        type: integer
    Retry-After:
      description: >-
        The number of seconds the client should wait before making a new
        request.
      schema:
        type: integer
    X-Auth0-Error-Kind:
      description: >-
        An indicator that the rate limit exceeded a is global (per tenant)
        limit.
      schema:
        type: string
        enum:
          - global-rate-limit
  securitySchemes:
    OAuth2ClientCredentials:
      type: oauth2
      flows:
        clientCredentials:
          tokenUrl: /oauth/token
          x-form-parameters:
            audience: /myorg-api/v1/
          scopes:
            read:my_org:configuration: Read organization configuration
            read:my_org:details: Read organization details
            update:my_org:details: Update organization details
            read:my_org:identity_providers: Read identity providers for organization
            create:my_org:identity_providers: Create identity provider for organization
            update:my_org:identity_providers: Update identity provider for organization
            delete:my_org:identity_providers: Delete identity provider for organization
            update:my_org:identity_providers_detach: Detach identity provider from organization
            create:my_org:identity_providers_domains: Associate organization domain with identity provider
            delete:my_org:identity_providers_domains: Remove organization domain from identity provider
            create:my_org:domains: Create domain for organization
            read:my_org:domains: Read domains for organization
            update:my_org:domains: Update domain for organization
            delete:my_org:domains: Delete domain for organization
            create:my_org:identity_providers_provisioning: Create provisioning configuration for identity provider
            update:my_org:identity_providers_provisioning: Update provisioning configuration for identity provider
            read:my_org:identity_providers_provisioning: Read provisioning configuration for identity provider
            delete:my_org:identity_providers_provisioning: Delete provisioning configuration for identity provider
            create:my_org:identity_providers_tests: Start identity provider tests for organization
            read:my_org:identity_providers_tests: Read identity provider tests for organization
            create:my_org:identity_providers_scim_tokens: Create a provisioning SCIM token for this identity provider
            read:my_org:identity_providers_scim_tokens: List the provisioning SCIM tokens for this identity provider
            delete:my_org:identity_providers_scim_tokens: Delete a provisioning SCIM configuration for an identity provider
            read:my_org:member_invitations: List member invitations for organization
            create:my_org:member_invitations: Create member invitations for organization
            delete:my_org:member_invitations: Delete member invitations for organization
            read:my_org:members: List members for organization
            delete:my_org:memberships: Delete members from organization without deleting underlying users
            read:my_org:member_roles: List Roles for members in organization
            create:my_org:member_roles: Create Roles for members in organization
            delete:my_org:member_roles: Delete Roles from members for organization
            create:my_org:client_grants: Create client grants for client in organization
            create:my_org:clients: Create API clients for organization
            read:my_org:clients: Read API clients for organization
            delete:my_org:clients: Delete API clients for organization
            read:my_org:user_stores: Read user stores for an organization
            delete:my_org:organizations: Delete this organization
            read:my_org:groups: List connection groups for organization
            read:my_org:group_roles: List roles for a group in organization
            create:my_org:group_roles: Assign roles to a group in organization
            delete:my_org:group_roles: Remove roles from a group in organization
    OAuth2AuthCode:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: /authorize
          tokenUrl: /oauth/token
          x-form-parameters:
            audience: /myorg-api/v1/
          scopes:
            read:my_org:configuration: Read organization configuration
            read:my_org:details: Read organization details
            update:my_org:details: Update organization details
            read:my_org:identity_providers: Read identity providers for organization
            create:my_org:identity_providers: Create identity provider for organization
            update:my_org:identity_providers: Update identity provider for organization
            delete:my_org:identity_providers: Delete identity provider for organization
            update:my_org:identity_providers_detach: Detach identity provider from organization
            create:my_org:identity_providers_domains: Associate organization domain with identity provider
            delete:my_org:identity_providers_domains: Remove organization domain from identity provider
            create:my_org:domains: Create domain for organization
            read:my_org:domains: Read domains for organization
            update:my_org:domains: Update domain for organization
            delete:my_org:domains: Delete domain for organization
            create:my_org:identity_providers_provisioning: Create provisioning configuration for identity provider
            update:my_org:identity_providers_provisioning: Update provisioning configuration for identity provider
            read:my_org:identity_providers_provisioning: Read provisioning configuration for identity provider
            delete:my_org:identity_providers_provisioning: Delete provisioning configuration for identity provider
            create:my_org:identity_providers_tests: Start identity provider tests for organization
            read:my_org:identity_providers_tests: Read identity provider tests for organization
            create:my_org:identity_providers_scim_tokens: Create a provisioning SCIM token for this identity provider
            read:my_org:identity_providers_scim_tokens: List the provisioning SCIM tokens for this identity provider
            delete:my_org:identity_providers_scim_tokens: Delete a provisioning SCIM configuration for an identity provider
            read:my_org:member_invitations: List member invitations for organization
            create:my_org:member_invitations: Create member invitations for organization
            delete:my_org:member_invitations: Delete member invitations for organization
            read:my_org:members: List members for organization
            delete:my_org:memberships: Delete members from organization without deleting underlying users
            read:my_org:member_roles: List Roles for members in organization
            create:my_org:member_roles: Create Roles for members in organization
            delete:my_org:member_roles: Delete Roles from members for organization
            create:my_org:client_grants: Create client grants for client in organization
            create:my_org:clients: Create API clients for organization
            read:my_org:clients: Read API clients for organization
            delete:my_org:clients: Delete API clients for organization
            read:my_org:user_stores: Read user stores for an organization
            delete:my_org:organizations: Delete this organization
            read:my_org:groups: List connection groups for organization
            read:my_org:group_roles: List roles for a group in organization
            create:my_org:group_roles: Assign roles to a group in organization
            delete:my_org:group_roles: Remove roles from a group in organization

````